Back to home page

OSCL-LXR

 
 

    


0001 #!/bin/sh
0002 # probe libc's inet_pton & backtrace it with ping
0003 
0004 # Installs a probe on libc's inet_pton function, that will use uprobes,
0005 # then use 'perf trace' on a ping to localhost asking for just one packet
0006 # with the a backtrace 3 levels deep, check that it is what we expect.
0007 # This needs no debuginfo package, all is done using the libc ELF symtab
0008 # and the CFI info in the binaries.
0009 
0010 # SPDX-License-Identifier: GPL-2.0
0011 # Arnaldo Carvalho de Melo <acme@kernel.org>, 2017
0012 
0013 . $(dirname $0)/lib/probe.sh
0014 
0015 libc=$(grep -w libc /proc/self/maps | head -1 | sed -r 's/.*[[:space:]](\/.*)/\1/g')
0016 nm -Dg $libc 2>/dev/null | fgrep -q inet_pton || exit 254
0017 
0018 event_pattern='probe_libc:inet_pton(\_[[:digit:]]+)?'
0019 
0020 add_libc_inet_pton_event() {
0021 
0022         event_name=$(perf probe -f -x $libc -a inet_pton 2>&1 | tail -n +2 | head -n -5 | \
0023                         grep -P -o "$event_pattern(?=[[:space:]]\(on inet_pton in $libc\))")
0024 
0025         if [ $? -ne 0 -o -z "$event_name" ] ; then
0026                 printf "FAIL: could not add event\n"
0027                 return 1
0028         fi
0029 }
0030 
0031 trace_libc_inet_pton_backtrace() {
0032 
0033         expected=`mktemp -u /tmp/expected.XXX`
0034 
0035         echo "ping[][0-9 \.:]+$event_name: \([[:xdigit:]]+\)" > $expected
0036         echo ".*inet_pton\+0x[[:xdigit:]]+[[:space:]]\($libc|inlined\)$" >> $expected
0037         case "$(uname -m)" in
0038         s390x)
0039                 eventattr='call-graph=dwarf,max-stack=4'
0040                 echo "gaih_inet.*\+0x[[:xdigit:]]+[[:space:]]\($libc|inlined\)$" >> $expected
0041                 echo "(__GI_)?getaddrinfo\+0x[[:xdigit:]]+[[:space:]]\($libc|inlined\)$" >> $expected
0042                 echo "main\+0x[[:xdigit:]]+[[:space:]]\(.*/bin/ping.*\)$" >> $expected
0043                 ;;
0044         ppc64|ppc64le)
0045                 eventattr='max-stack=4'
0046                 echo "gaih_inet.*\+0x[[:xdigit:]]+[[:space:]]\($libc\)$" >> $expected
0047                 echo "getaddrinfo\+0x[[:xdigit:]]+[[:space:]]\($libc\)$" >> $expected
0048                 echo ".*(\+0x[[:xdigit:]]+|\[unknown\])[[:space:]]\(.*/bin/ping.*\)$" >> $expected
0049                 ;;
0050         *)
0051                 eventattr='max-stack=3'
0052                 echo "getaddrinfo\+0x[[:xdigit:]]+[[:space:]]\($libc\)$" >> $expected
0053                 echo ".*(\+0x[[:xdigit:]]+|\[unknown\])[[:space:]]\(.*/bin/ping.*\)$" >> $expected
0054                 ;;
0055         esac
0056 
0057         perf_data=`mktemp -u /tmp/perf.data.XXX`
0058         perf_script=`mktemp -u /tmp/perf.script.XXX`
0059         perf record -e $event_name/$eventattr/ -o $perf_data ping -6 -c 1 ::1 > /dev/null 2>&1
0060         perf script -i $perf_data > $perf_script
0061 
0062         exec 3<$perf_script
0063         exec 4<$expected
0064         while read line <&3 && read -r pattern <&4; do
0065                 [ -z "$pattern" ] && break
0066                 echo $line
0067                 echo "$line" | egrep -q "$pattern"
0068                 if [ $? -ne 0 ] ; then
0069                         printf "FAIL: expected backtrace entry \"%s\" got \"%s\"\n" "$pattern" "$line"
0070                         return 1
0071                 fi
0072         done
0073 
0074         # If any statements are executed from this point onwards,
0075         # the exit code of the last among these will be reflected
0076         # in err below. If the exit code is 0, the test will pass
0077         # even if the perf script output does not match.
0078 }
0079 
0080 delete_libc_inet_pton_event() {
0081 
0082         if [ -n "$event_name" ] ; then
0083                 perf probe -q -d $event_name
0084         fi
0085 }
0086 
0087 # Check for IPv6 interface existence
0088 ip a sh lo | fgrep -q inet6 || exit 2
0089 
0090 skip_if_no_perf_probe && \
0091 add_libc_inet_pton_event && \
0092 trace_libc_inet_pton_backtrace
0093 err=$?
0094 rm -f ${perf_data} ${perf_script} ${expected}
0095 delete_libc_inet_pton_event
0096 exit $err